<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.15"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>Nano102_112 Series BSP: Smartcard Library Exported Functions</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectlogo"><img alt="Logo" src="M0Banner_v2.jpg"/></td>
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">Nano102_112 Series BSP
   &#160;<span id="projectnumber">V3.03.002</span>
   </div>
   <div id="projectbrief">The Board Support Package for  Nano102_112 Series</div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.15 -->
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(function() {
  initMenu('',false,false,'search.php','Search');
});
/* @license-end */</script>
<div id="main-nav"></div>
</div><!-- top -->
<div class="header">
  <div class="summary">
<a href="#func-members">Functions</a>  </div>
  <div class="headertitle">
<div class="title">Smartcard Library Exported Functions<div class="ingroups"><a class="el" href="group___n_a_n_o1_x2___library.html">NANO102/112 Library</a> &raquo; <a class="el" href="group___n_a_n_o1_x2___s_c_l_i_b.html">Smartcard Library</a></div></div>  </div>
</div><!--header-->
<div class="contents">
<table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="func-members"></a>
Functions</h2></td></tr>
<tr class="memitem:gabb70ec55d6f58ee4286fc3272b9f7a4b"><td class="memItemLeft" align="right" valign="top">int32_t&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group___n_a_n_o100___s_c_l_i_b___e_x_p_o_r_t_e_d___f_u_n_c_t_i_o_n_s.html#gabb70ec55d6f58ee4286fc3272b9f7a4b">SCLIB_Activate</a> (uint32_t num, uint32_t u32EMVCheck)</td></tr>
<tr class="memdesc:gabb70ec55d6f58ee4286fc3272b9f7a4b"><td class="mdescLeft">&#160;</td><td class="mdescRight">Activate a smartcard.  <a href="#gabb70ec55d6f58ee4286fc3272b9f7a4b">More...</a><br /></td></tr>
<tr class="separator:gabb70ec55d6f58ee4286fc3272b9f7a4b"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ga7c6f434ac0e08d9a2a4c25e42e9d91cc"><td class="memItemLeft" align="right" valign="top">int32_t&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group___n_a_n_o100___s_c_l_i_b___e_x_p_o_r_t_e_d___f_u_n_c_t_i_o_n_s.html#ga7c6f434ac0e08d9a2a4c25e42e9d91cc">SCLIB_ActivateDelay</a> (uint32_t num, uint32_t u32EMVCheck, uint32_t u32Delay)</td></tr>
<tr class="memdesc:ga7c6f434ac0e08d9a2a4c25e42e9d91cc"><td class="mdescLeft">&#160;</td><td class="mdescRight">Activate a smartcard with large delay between set VCC high and start CLK output.  <a href="#ga7c6f434ac0e08d9a2a4c25e42e9d91cc">More...</a><br /></td></tr>
<tr class="separator:ga7c6f434ac0e08d9a2a4c25e42e9d91cc"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:gae308ef6ac6809fd3cf8535f617ba280c"><td class="memItemLeft" align="right" valign="top">int32_t&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group___n_a_n_o100___s_c_l_i_b___e_x_p_o_r_t_e_d___f_u_n_c_t_i_o_n_s.html#gae308ef6ac6809fd3cf8535f617ba280c">SCLIB_ColdReset</a> (uint32_t num)</td></tr>
<tr class="memdesc:gae308ef6ac6809fd3cf8535f617ba280c"><td class="mdescLeft">&#160;</td><td class="mdescRight">Cold reset a smartcard.  <a href="#gae308ef6ac6809fd3cf8535f617ba280c">More...</a><br /></td></tr>
<tr class="separator:gae308ef6ac6809fd3cf8535f617ba280c"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:gadd3bacc5128a7ce612a6781f7f44d49c"><td class="memItemLeft" align="right" valign="top">int32_t&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group___n_a_n_o100___s_c_l_i_b___e_x_p_o_r_t_e_d___f_u_n_c_t_i_o_n_s.html#gadd3bacc5128a7ce612a6781f7f44d49c">SCLIB_WarmReset</a> (uint32_t num)</td></tr>
<tr class="memdesc:gadd3bacc5128a7ce612a6781f7f44d49c"><td class="mdescLeft">&#160;</td><td class="mdescRight">Warm reset a smartcard.  <a href="#gadd3bacc5128a7ce612a6781f7f44d49c">More...</a><br /></td></tr>
<tr class="separator:gadd3bacc5128a7ce612a6781f7f44d49c"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:gaa04a140bba7b6392d9ca01833d74f8b6"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group___n_a_n_o100___s_c_l_i_b___e_x_p_o_r_t_e_d___f_u_n_c_t_i_o_n_s.html#gaa04a140bba7b6392d9ca01833d74f8b6">SCLIB_Deactivate</a> (uint32_t num)</td></tr>
<tr class="memdesc:gaa04a140bba7b6392d9ca01833d74f8b6"><td class="mdescLeft">&#160;</td><td class="mdescRight">Deactivate a smartcard.  <a href="#gaa04a140bba7b6392d9ca01833d74f8b6">More...</a><br /></td></tr>
<tr class="separator:gaa04a140bba7b6392d9ca01833d74f8b6"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:gac7143f2e0b766a7be1884020ef5798ce"><td class="memItemLeft" align="right" valign="top">int32_t&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group___n_a_n_o100___s_c_l_i_b___e_x_p_o_r_t_e_d___f_u_n_c_t_i_o_n_s.html#gac7143f2e0b766a7be1884020ef5798ce">SCLIB_GetCardInfo</a> (uint32_t num, <a class="el" href="struct_s_c_l_i_b___c_a_r_d___i_n_f_o___t.html">SCLIB_CARD_INFO_T</a> *s_info)</td></tr>
<tr class="memdesc:gac7143f2e0b766a7be1884020ef5798ce"><td class="mdescLeft">&#160;</td><td class="mdescRight">Get the card information (e.g., protocol selected, ATR...) after activation success.  <a href="#gac7143f2e0b766a7be1884020ef5798ce">More...</a><br /></td></tr>
<tr class="separator:gac7143f2e0b766a7be1884020ef5798ce"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:gad36d1c312fd93f25445a44a6f1b9363d"><td class="memItemLeft" align="right" valign="top">int32_t&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group___n_a_n_o100___s_c_l_i_b___e_x_p_o_r_t_e_d___f_u_n_c_t_i_o_n_s.html#gad36d1c312fd93f25445a44a6f1b9363d">SCLIB_StartTransmission</a> (uint32_t num, uint8_t *cmdBuf, uint32_t cmdLen, uint8_t *rspBuf, uint32_t *rspLen)</td></tr>
<tr class="memdesc:gad36d1c312fd93f25445a44a6f1b9363d"><td class="mdescLeft">&#160;</td><td class="mdescRight">Start a smartcard transmission.  <a href="#gad36d1c312fd93f25445a44a6f1b9363d">More...</a><br /></td></tr>
<tr class="separator:gad36d1c312fd93f25445a44a6f1b9363d"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ga1586bc952411d6a6b162acabc1db94a6"><td class="memItemLeft" align="right" valign="top">int32_t&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group___n_a_n_o100___s_c_l_i_b___e_x_p_o_r_t_e_d___f_u_n_c_t_i_o_n_s.html#ga1586bc952411d6a6b162acabc1db94a6">SCLIB_SetIFSD</a> (uint32_t num, uint8_t size)</td></tr>
<tr class="memdesc:ga1586bc952411d6a6b162acabc1db94a6"><td class="mdescLeft">&#160;</td><td class="mdescRight">Set interface device max information field size (IFSD)  <a href="#ga1586bc952411d6a6b162acabc1db94a6">More...</a><br /></td></tr>
<tr class="separator:ga1586bc952411d6a6b162acabc1db94a6"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ga6b9c94a9a190283ad41ae0ee0df22fa9"><td class="memItemLeft" align="right" valign="top">__weak void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group___n_a_n_o100___s_c_l_i_b___e_x_p_o_r_t_e_d___f_u_n_c_t_i_o_n_s.html#ga6b9c94a9a190283ad41ae0ee0df22fa9">SCLIB_RequestTimeExtension</a> (uint32_t u32Protocol)</td></tr>
<tr class="memdesc:ga6b9c94a9a190283ad41ae0ee0df22fa9"><td class="mdescLeft">&#160;</td><td class="mdescRight">A callback called by library while smartcard request for a time extension.  <a href="#ga6b9c94a9a190283ad41ae0ee0df22fa9">More...</a><br /></td></tr>
<tr class="separator:ga6b9c94a9a190283ad41ae0ee0df22fa9"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ga550d72b74b7c55e903ff74fabd8c7019"><td class="memItemLeft" align="right" valign="top">uint32_t&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group___n_a_n_o100___s_c_l_i_b___e_x_p_o_r_t_e_d___f_u_n_c_t_i_o_n_s.html#ga550d72b74b7c55e903ff74fabd8c7019">SCLIB_CheckCDEvent</a> (uint32_t num)</td></tr>
<tr class="memdesc:ga550d72b74b7c55e903ff74fabd8c7019"><td class="mdescLeft">&#160;</td><td class="mdescRight">Process card detect event in IRQ handler.  <a href="#ga550d72b74b7c55e903ff74fabd8c7019">More...</a><br /></td></tr>
<tr class="separator:ga550d72b74b7c55e903ff74fabd8c7019"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:gaf833db82065ae92a02d10cd51eeac446"><td class="memItemLeft" align="right" valign="top">uint32_t&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group___n_a_n_o100___s_c_l_i_b___e_x_p_o_r_t_e_d___f_u_n_c_t_i_o_n_s.html#gaf833db82065ae92a02d10cd51eeac446">SCLIB_CheckTimeOutEvent</a> (uint32_t num)</td></tr>
<tr class="memdesc:gaf833db82065ae92a02d10cd51eeac446"><td class="mdescLeft">&#160;</td><td class="mdescRight">Process time out event in IRQ handler.  <a href="#gaf833db82065ae92a02d10cd51eeac446">More...</a><br /></td></tr>
<tr class="separator:gaf833db82065ae92a02d10cd51eeac446"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:gadc614ae52055d0af1ecbd9416976c276"><td class="memItemLeft" align="right" valign="top">uint32_t&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group___n_a_n_o100___s_c_l_i_b___e_x_p_o_r_t_e_d___f_u_n_c_t_i_o_n_s.html#gadc614ae52055d0af1ecbd9416976c276">SCLIB_CheckTxRxEvent</a> (uint32_t num)</td></tr>
<tr class="memdesc:gadc614ae52055d0af1ecbd9416976c276"><td class="mdescLeft">&#160;</td><td class="mdescRight">Process card transmission event in IRQ handler.  <a href="#gadc614ae52055d0af1ecbd9416976c276">More...</a><br /></td></tr>
<tr class="separator:gadc614ae52055d0af1ecbd9416976c276"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ga36ecb4214440705a023114a3a1b9a6fc"><td class="memItemLeft" align="right" valign="top">uint32_t&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group___n_a_n_o100___s_c_l_i_b___e_x_p_o_r_t_e_d___f_u_n_c_t_i_o_n_s.html#ga36ecb4214440705a023114a3a1b9a6fc">SCLIB_CheckErrorEvent</a> (uint32_t num)</td></tr>
<tr class="memdesc:ga36ecb4214440705a023114a3a1b9a6fc"><td class="mdescLeft">&#160;</td><td class="mdescRight">Process error event in IRQ handler.  <a href="#ga36ecb4214440705a023114a3a1b9a6fc">More...</a><br /></td></tr>
<tr class="separator:ga36ecb4214440705a023114a3a1b9a6fc"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table>
<a name="details" id="details"></a><h2 class="groupheader">Detailed Description</h2>
<h2 class="groupheader">Function Documentation</h2>
<a id="gabb70ec55d6f58ee4286fc3272b9f7a4b"></a>
<h2 class="memtitle"><span class="permalink"><a href="#gabb70ec55d6f58ee4286fc3272b9f7a4b">&#9670;&nbsp;</a></span>SCLIB_Activate()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">int32_t SCLIB_Activate </td>
          <td>(</td>
          <td class="paramtype">uint32_t&#160;</td>
          <td class="paramname"><em>num</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">uint32_t&#160;</td>
          <td class="paramname"><em>u32EMVCheck</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Activate a smartcard. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramdir">[in]</td><td class="paramname">num</td><td>Smartcard interface number. From 0 ~ ( <a class="el" href="group___n_a_n_o1_x2___s_c___e_x_p_o_r_t_e_d___c_o_n_s_t_a_n_t_s.html#gab1a473b529ef7082465c9a36b4be3472">SC_INTERFACE_NUM</a> - 1) </td></tr>
    <tr><td class="paramdir">[in]</td><td class="paramname">u32EMVCheck</td><td>Enable EMV error check or not. Valid setting are <a class="el" href="group___n_a_n_o1_x2__legacy___constants.html#gaa8cecfc5c5c054d2875c03e77b7be15d">TRUE</a> and <a class="el" href="group___n_a_n_o1_x2__legacy___constants.html#gaa93f0eb578d23995850d61f7d61c55c1">FALSE</a>. By enable EMV error checking, this library will perform ATR checking according to EMV book 1 specification. Otherwise, the error checking follows ISO 7816-3 </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>Smartcard successfully activated or not </dd></dl>
<dl class="retval"><dt>Return values</dt><dd>
  <table class="retval">
    <tr><td class="paramname">SCLIB_SUCCESS</td><td>Smartcard activated successfully </td></tr>
    <tr><td class="paramname">Others</td><td>Smartcard activation failed </td></tr>
  </table>
  </dd>
</dl>
<dl class="section note"><dt>Note</dt><dd>It is required to set smartcard interface clock between 1 MHz and 5 MHz before calling this API, otherwise this API return with <a class="el" href="group___n_a_n_o1_x2___s_c_l_i_b___e_x_p_o_r_t_e_d___c_o_n_s_t_a_n_t_s.html#ga5728870d0f41ac134b17e54ee3be4a3b">SCLIB_ERR_CLOCK</a> error code. </dd>
<dd>
EMV book 1 is stricter than ISO-7816 on ATR checking. Enable EMV check iff the application supports EMV cards only. </dd>
<dd>
Application should call this API after <a class="el" href="group___n_a_n_o1_x2___s_c___e_x_p_o_r_t_e_d___f_u_n_c_t_i_o_n_s.html#ga3fb708b1684dff67a8ce2c3951e55731" title="This function initialized smartcard module.">SC_Open()</a> and SC NVIC enabled </dd></dl>

</div>
</div>
<a id="ga7c6f434ac0e08d9a2a4c25e42e9d91cc"></a>
<h2 class="memtitle"><span class="permalink"><a href="#ga7c6f434ac0e08d9a2a4c25e42e9d91cc">&#9670;&nbsp;</a></span>SCLIB_ActivateDelay()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">int32_t SCLIB_ActivateDelay </td>
          <td>(</td>
          <td class="paramtype">uint32_t&#160;</td>
          <td class="paramname"><em>num</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">uint32_t&#160;</td>
          <td class="paramname"><em>u32EMVCheck</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">uint32_t&#160;</td>
          <td class="paramname"><em>u32Delay</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Activate a smartcard with large delay between set VCC high and start CLK output. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramdir">[in]</td><td class="paramname">num</td><td>Smartcard interface number. From 0 ~ ( <a class="el" href="group___n_a_n_o1_x2___s_c___e_x_p_o_r_t_e_d___c_o_n_s_t_a_n_t_s.html#gab1a473b529ef7082465c9a36b4be3472">SC_INTERFACE_NUM</a> - 1) </td></tr>
    <tr><td class="paramdir">[in]</td><td class="paramname">u32EMVCheck</td><td>Enable EMV error check or not. Valid setting are <a class="el" href="group___n_a_n_o1_x2__legacy___constants.html#gaa8cecfc5c5c054d2875c03e77b7be15d">TRUE</a> and <a class="el" href="group___n_a_n_o1_x2__legacy___constants.html#gaa93f0eb578d23995850d61f7d61c55c1">FALSE</a>. By enable EMV error checking, this library will perform ATR checking according to EMV book 1 specification. Otherwise, the error checking follows ISO 7816-3 </td></tr>
    <tr><td class="paramdir">[in]</td><td class="paramname">u32Delay</td><td>Extra delay time between set VCC high and start CLK output, using ETU as time unit. </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>Smartcard successfully activated or not </dd></dl>
<dl class="retval"><dt>Return values</dt><dd>
  <table class="retval">
    <tr><td class="paramname">SCLIB_SUCCESS</td><td>Smartcard activated successfully </td></tr>
    <tr><td class="paramname">Others</td><td>Smartcard activation failed </td></tr>
  </table>
  </dd>
</dl>
<dl class="section note"><dt>Note</dt><dd>It is required to set smartcard interface clock between 1 MHz and 5 MHz before calling this API, otherwise this API return with <a class="el" href="group___n_a_n_o1_x2___s_c_l_i_b___e_x_p_o_r_t_e_d___c_o_n_s_t_a_n_t_s.html#ga5728870d0f41ac134b17e54ee3be4a3b">SCLIB_ERR_CLOCK</a> error code. </dd>
<dd>
EMV book 1 is stricter than ISO-7816 on ATR checking. Enable EMV check iff the application supports EMV cards only. </dd>
<dd>
Only use this function instead of <a class="el" href="group___n_a_n_o100___s_c_l_i_b___e_x_p_o_r_t_e_d___f_u_n_c_t_i_o_n_s.html#gabb70ec55d6f58ee4286fc3272b9f7a4b">SCLIB_Activate</a> if there's large capacitor on VCC pin and VCC raise slowly. </dd></dl>

</div>
</div>
<a id="ga550d72b74b7c55e903ff74fabd8c7019"></a>
<h2 class="memtitle"><span class="permalink"><a href="#ga550d72b74b7c55e903ff74fabd8c7019">&#9670;&nbsp;</a></span>SCLIB_CheckCDEvent()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">uint32_t SCLIB_CheckCDEvent </td>
          <td>(</td>
          <td class="paramtype">uint32_t&#160;</td>
          <td class="paramname"><em>num</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Process card detect event in IRQ handler. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramdir">[in]</td><td class="paramname">num</td><td>Smartcard interface number. From 0 ~ ( <a class="el" href="group___n_a_n_o1_x2___s_c___e_x_p_o_r_t_e_d___c_o_n_s_t_a_n_t_s.html#gab1a473b529ef7082465c9a36b4be3472">SC_INTERFACE_NUM</a> - 1) </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>Card detect event occur or not </dd></dl>
<dl class="retval"><dt>Return values</dt><dd>
  <table class="retval">
    <tr><td class="paramname">1</td><td>Card detect event occurred </td></tr>
    <tr><td class="paramname">0</td><td>Card detect event did not occur </td></tr>
  </table>
  </dd>
</dl>
<dl class="section note"><dt>Note</dt><dd>Smartcard IRQ handler shall call this function with correct interface number as parameter if and only if the smartcard slot has a card detect signal </dd></dl>

</div>
</div>
<a id="ga36ecb4214440705a023114a3a1b9a6fc"></a>
<h2 class="memtitle"><span class="permalink"><a href="#ga36ecb4214440705a023114a3a1b9a6fc">&#9670;&nbsp;</a></span>SCLIB_CheckErrorEvent()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">uint32_t SCLIB_CheckErrorEvent </td>
          <td>(</td>
          <td class="paramtype">uint32_t&#160;</td>
          <td class="paramname"><em>num</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Process error event in IRQ handler. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramdir">[in]</td><td class="paramname">num</td><td>Smartcard interface number. From 0 ~ ( <a class="el" href="group___n_a_n_o1_x2___s_c___e_x_p_o_r_t_e_d___c_o_n_s_t_a_n_t_s.html#gab1a473b529ef7082465c9a36b4be3472">SC_INTERFACE_NUM</a> - 1) </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>Error event occur or not </dd></dl>
<dl class="retval"><dt>Return values</dt><dd>
  <table class="retval">
    <tr><td class="paramname">1</td><td>Error event occurred </td></tr>
    <tr><td class="paramname">0</td><td>Error event did not occur </td></tr>
  </table>
  </dd>
</dl>
<dl class="section note"><dt>Note</dt><dd>Smartcard IRQ handler shall call this function with correct interface number as parameter </dd></dl>

</div>
</div>
<a id="gaf833db82065ae92a02d10cd51eeac446"></a>
<h2 class="memtitle"><span class="permalink"><a href="#gaf833db82065ae92a02d10cd51eeac446">&#9670;&nbsp;</a></span>SCLIB_CheckTimeOutEvent()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">uint32_t SCLIB_CheckTimeOutEvent </td>
          <td>(</td>
          <td class="paramtype">uint32_t&#160;</td>
          <td class="paramname"><em>num</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Process time out event in IRQ handler. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramdir">[in]</td><td class="paramname">num</td><td>Smartcard interface number. From 0 ~ ( <a class="el" href="group___n_a_n_o1_x2___s_c___e_x_p_o_r_t_e_d___c_o_n_s_t_a_n_t_s.html#gab1a473b529ef7082465c9a36b4be3472">SC_INTERFACE_NUM</a> - 1) </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>Time out event occur or not </dd></dl>
<dl class="retval"><dt>Return values</dt><dd>
  <table class="retval">
    <tr><td class="paramname">1</td><td>Time out event occurred </td></tr>
    <tr><td class="paramname">0</td><td>Time out event did not occur </td></tr>
  </table>
  </dd>
</dl>
<dl class="section note"><dt>Note</dt><dd>Smartcard IRQ handler shall call this function with correct interface number as parameter </dd></dl>

</div>
</div>
<a id="gadc614ae52055d0af1ecbd9416976c276"></a>
<h2 class="memtitle"><span class="permalink"><a href="#gadc614ae52055d0af1ecbd9416976c276">&#9670;&nbsp;</a></span>SCLIB_CheckTxRxEvent()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">uint32_t SCLIB_CheckTxRxEvent </td>
          <td>(</td>
          <td class="paramtype">uint32_t&#160;</td>
          <td class="paramname"><em>num</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Process card transmission event in IRQ handler. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramdir">[in]</td><td class="paramname">num</td><td>Smartcard interface number. From 0 ~ ( <a class="el" href="group___n_a_n_o1_x2___s_c___e_x_p_o_r_t_e_d___c_o_n_s_t_a_n_t_s.html#gab1a473b529ef7082465c9a36b4be3472">SC_INTERFACE_NUM</a> - 1) </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>Transmission event occur or not </dd></dl>
<dl class="retval"><dt>Return values</dt><dd>
  <table class="retval">
    <tr><td class="paramname">1</td><td>Transmission event occurred </td></tr>
    <tr><td class="paramname">0</td><td>Transmission event did not occur </td></tr>
  </table>
  </dd>
</dl>
<dl class="section note"><dt>Note</dt><dd>Smartcard IRQ handler shall call this function with correct interface number as parameter </dd></dl>

</div>
</div>
<a id="gae308ef6ac6809fd3cf8535f617ba280c"></a>
<h2 class="memtitle"><span class="permalink"><a href="#gae308ef6ac6809fd3cf8535f617ba280c">&#9670;&nbsp;</a></span>SCLIB_ColdReset()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">int32_t SCLIB_ColdReset </td>
          <td>(</td>
          <td class="paramtype">uint32_t&#160;</td>
          <td class="paramname"><em>num</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Cold reset a smartcard. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramdir">[in]</td><td class="paramname">num</td><td>Smartcard interface number. From 0 ~ ( <a class="el" href="group___n_a_n_o1_x2___s_c___e_x_p_o_r_t_e_d___c_o_n_s_t_a_n_t_s.html#gab1a473b529ef7082465c9a36b4be3472">SC_INTERFACE_NUM</a> - 1) </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>Smartcard cold reset success or not </dd></dl>
<dl class="retval"><dt>Return values</dt><dd>
  <table class="retval">
    <tr><td class="paramname">SCLIB_SUCCESS</td><td>Smartcard cold reset success </td></tr>
    <tr><td class="paramname">Others</td><td>Smartcard cold reset failed </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a id="gaa04a140bba7b6392d9ca01833d74f8b6"></a>
<h2 class="memtitle"><span class="permalink"><a href="#gaa04a140bba7b6392d9ca01833d74f8b6">&#9670;&nbsp;</a></span>SCLIB_Deactivate()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void SCLIB_Deactivate </td>
          <td>(</td>
          <td class="paramtype">uint32_t&#160;</td>
          <td class="paramname"><em>num</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Deactivate a smartcard. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramdir">[in]</td><td class="paramname">num</td><td>Smartcard interface number. From 0 ~ ( <a class="el" href="group___n_a_n_o1_x2___s_c___e_x_p_o_r_t_e_d___c_o_n_s_t_a_n_t_s.html#gab1a473b529ef7082465c9a36b4be3472">SC_INTERFACE_NUM</a> - 1) </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>None </dd></dl>

</div>
</div>
<a id="gac7143f2e0b766a7be1884020ef5798ce"></a>
<h2 class="memtitle"><span class="permalink"><a href="#gac7143f2e0b766a7be1884020ef5798ce">&#9670;&nbsp;</a></span>SCLIB_GetCardInfo()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">int32_t SCLIB_GetCardInfo </td>
          <td>(</td>
          <td class="paramtype">uint32_t&#160;</td>
          <td class="paramname"><em>num</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="struct_s_c_l_i_b___c_a_r_d___i_n_f_o___t.html">SCLIB_CARD_INFO_T</a> *&#160;</td>
          <td class="paramname"><em>s_info</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Get the card information (e.g., protocol selected, ATR...) after activation success. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramdir">[in]</td><td class="paramname">num</td><td>Smartcard interface number. From 0 ~ ( <a class="el" href="group___n_a_n_o1_x2___s_c___e_x_p_o_r_t_e_d___c_o_n_s_t_a_n_t_s.html#gab1a473b529ef7082465c9a36b4be3472">SC_INTERFACE_NUM</a> - 1) </td></tr>
    <tr><td class="paramdir">[out]</td><td class="paramname">s_info</td><td>A pointer to <a class="el" href="struct_s_c_l_i_b___c_a_r_d___i_n_f_o___t.html">SCLIB_CARD_INFO_T</a> holds the card information </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>Success or not </dd></dl>
<dl class="retval"><dt>Return values</dt><dd>
  <table class="retval">
    <tr><td class="paramname">SCLIB_SUCCESS</td><td>Success, s_info contains card information </td></tr>
    <tr><td class="paramname">SCLIB_ERR_CARD_REMOVED</td><td>Card removed, s_info does not contains card information </td></tr>
    <tr><td class="paramname">SCLIB_ERR_DEACTIVE</td><td>Card is deactivated, s_info does not contains card information </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a id="ga6b9c94a9a190283ad41ae0ee0df22fa9"></a>
<h2 class="memtitle"><span class="permalink"><a href="#ga6b9c94a9a190283ad41ae0ee0df22fa9">&#9670;&nbsp;</a></span>SCLIB_RequestTimeExtension()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">__weak void SCLIB_RequestTimeExtension </td>
          <td>(</td>
          <td class="paramtype">uint32_t&#160;</td>
          <td class="paramname"><em>u32Protocol</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>A callback called by library while smartcard request for a time extension. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramdir">[in]</td><td class="paramname">u32Protocol</td><td>What protocol the card is using while it requested for a time extension. Could be ether <a class="el" href="group___n_a_n_o1_x2___s_c_l_i_b___e_x_p_o_r_t_e_d___c_o_n_s_t_a_n_t_s.html#ga55cce06161110dc2a75423459dff8392">SCLIB_PROTOCOL_T0</a> or <a class="el" href="group___n_a_n_o1_x2___s_c_l_i_b___e_x_p_o_r_t_e_d___c_o_n_s_t_a_n_t_s.html#gaceb47970d665912809b843c7adb9dd28">SCLIB_PROTOCOL_T1</a> </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>None </dd></dl>
<dl class="section note"><dt>Note</dt><dd>This function is defined with __weak attribute and does nothing in library. Application can provide its own time extension function. For example, and CCID reader can use this function to report this status to PC. See CCID rev 1.1 Table 6.2-3 </dd></dl>

</div>
</div>
<a id="ga1586bc952411d6a6b162acabc1db94a6"></a>
<h2 class="memtitle"><span class="permalink"><a href="#ga1586bc952411d6a6b162acabc1db94a6">&#9670;&nbsp;</a></span>SCLIB_SetIFSD()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">int32_t SCLIB_SetIFSD </td>
          <td>(</td>
          <td class="paramtype">uint32_t&#160;</td>
          <td class="paramname"><em>num</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">uint8_t&#160;</td>
          <td class="paramname"><em>size</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Set interface device max information field size (IFSD) </p>
<p>This function sends S block to notify card about the max size of information filed blocks that can be received by the interface device. According to EMV 9.2.4.3, this should be the first block transmitted by terminal to ICC after ATR. </p><dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramdir">[in]</td><td class="paramname">num</td><td>Smartcard interface number. From 0 ~ ( <a class="el" href="group___n_a_n_o1_x2___s_c___e_x_p_o_r_t_e_d___c_o_n_s_t_a_n_t_s.html#gab1a473b529ef7082465c9a36b4be3472">SC_INTERFACE_NUM</a> - 1) </td></tr>
    <tr><td class="paramdir">[in]</td><td class="paramname">size</td><td>IFSD size. According to EMV spec 9.2.4.3 Error Free Operation, this field must be 0xFE. </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>Smartcard transmission success or failed </dd></dl>
<dl class="retval"><dt>Return values</dt><dd>
  <table class="retval">
    <tr><td class="paramname">SCLIB_SUCCESS</td><td>Smartcard warm reset success </td></tr>
    <tr><td class="paramname">Others</td><td>Smartcard warm reset failed </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a id="gad36d1c312fd93f25445a44a6f1b9363d"></a>
<h2 class="memtitle"><span class="permalink"><a href="#gad36d1c312fd93f25445a44a6f1b9363d">&#9670;&nbsp;</a></span>SCLIB_StartTransmission()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">int32_t SCLIB_StartTransmission </td>
          <td>(</td>
          <td class="paramtype">uint32_t&#160;</td>
          <td class="paramname"><em>num</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">uint8_t *&#160;</td>
          <td class="paramname"><em>cmdBuf</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">uint32_t&#160;</td>
          <td class="paramname"><em>cmdLen</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">uint8_t *&#160;</td>
          <td class="paramname"><em>rspBuf</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">uint32_t *&#160;</td>
          <td class="paramname"><em>rspLen</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Start a smartcard transmission. </p>
<p>SCLIB will start a transmission according to the protocol selected </p><dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramdir">[in]</td><td class="paramname">num</td><td>Smartcard interface number. From 0 ~ ( <a class="el" href="group___n_a_n_o1_x2___s_c___e_x_p_o_r_t_e_d___c_o_n_s_t_a_n_t_s.html#gab1a473b529ef7082465c9a36b4be3472">SC_INTERFACE_NUM</a> - 1) </td></tr>
    <tr><td class="paramdir">[in]</td><td class="paramname">cmdBuf</td><td>Command buffer pointer </td></tr>
    <tr><td class="paramdir">[in]</td><td class="paramname">cmdLen</td><td>Command length </td></tr>
    <tr><td class="paramdir">[out]</td><td class="paramname">rspBuf</td><td>Buffer to holds card response </td></tr>
    <tr><td class="paramdir">[out]</td><td class="paramname">rspLen</td><td>Response length received </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>Smartcard transmission success or failed </dd></dl>
<dl class="retval"><dt>Return values</dt><dd>
  <table class="retval">
    <tr><td class="paramname">SCLIB_SUCCESS</td><td>Transmission success. rspBuf and rspLen holds response data and length </td></tr>
    <tr><td class="paramname">Others</td><td>Transmission failed </td></tr>
  </table>
  </dd>
</dl>
<dl class="section note"><dt>Note</dt><dd>This API supports case 1, 2S, 3S, and 4S defined in ISO-7816, but does <b>NOT</b> support case 2E, 3E, and 4E. </dd></dl>

</div>
</div>
<a id="gadd3bacc5128a7ce612a6781f7f44d49c"></a>
<h2 class="memtitle"><span class="permalink"><a href="#gadd3bacc5128a7ce612a6781f7f44d49c">&#9670;&nbsp;</a></span>SCLIB_WarmReset()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">int32_t SCLIB_WarmReset </td>
          <td>(</td>
          <td class="paramtype">uint32_t&#160;</td>
          <td class="paramname"><em>num</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Warm reset a smartcard. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramdir">[in]</td><td class="paramname">num</td><td>Smartcard interface number. From 0 ~ ( <a class="el" href="group___n_a_n_o1_x2___s_c___e_x_p_o_r_t_e_d___c_o_n_s_t_a_n_t_s.html#gab1a473b529ef7082465c9a36b4be3472">SC_INTERFACE_NUM</a> - 1) </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>Smartcard warm reset success or not </dd></dl>
<dl class="retval"><dt>Return values</dt><dd>
  <table class="retval">
    <tr><td class="paramname">SCLIB_SUCCESS</td><td>Smartcard warm reset success </td></tr>
    <tr><td class="paramname">Others</td><td>Smartcard warm reset failed </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
</div><!-- contents -->
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
Generated on Tue Oct 6 2020 19:17:54 for Nano102_112 Series BSP by &#160;<a href="http://www.doxygen.org/index.html">
<img class="footer" src="doxygen.png" alt="doxygen"/>
</a> 1.8.15
</small></address>
</body>
</html>
